package de.uni_marburg.powersort.MSort;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.IntStream;

import org.junit.jupiter.api.Test;

import static de.uni_marburg.powersort.MSort.IMPL_M_1.MERGE_COST;
import static de.uni_marburg.powersort.MSort.IMPL_M_1.fillWithAscRunsHighToLow;
import static de.uni_marburg.powersort.MSort.IMPL_M_1.powerSort;

class PowerSortTest {
    @Test
    public void testWithOneInputList() {
       // List<Integer> list = new ArrayList<>(List.of(5, 2, 8, 12, 1, 6));
       // extendRun(list, 0);
//System.out.println(list);
        // example from slides he wrote this
        int[] runs = {5, 3, 3, 14, 1, 2};
         runs = new int[]{9, 16, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7};

        List<Integer> a = new ArrayList<>(IntStream.range(0, Arrays.stream(runs).sum()).boxed().collect(Collectors.toList()));

        System.out.println();
        fillWithAscRunsHighToLow(a, runs, 1);
        MERGE_COST = 0;
        System.out.println("Sorting with Powersort:");
        //powerSort(a);
        System.out.println("Merge cost: " + MERGE_COST);
    }

    @Test
            public void testWithFinnInputList() {
        List<Integer> numbers = List.of(new Integer[] {24, 25, 26, 27, 28, 21, 22, 23, 18, 19, 20, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 3, 1, 2});

       // powerSort(numbers);
        System.out.println("Result: ");
        System.out.println(new ArrayList<>(List.of(numbers)));

    }
}
